package tokens_test

import (
	"context"
	"gitea.deepak.science/deepak/gogmagog/tokens"
	"github.com/stretchr/testify/assert"
	"testing"
)

func TestGoodContext(t *testing.T) {
	assert := assert.New(t)

	idToUse := 3
	username := "username"

	ctx := tokens.GetContextForUserValues(idToUse, username)

	receivedID, err := tokens.GetUserID(ctx)
	assert.Nil(err)
	assert.EqualValues(idToUse, receivedID)

	receivedUsername, err := tokens.GetUsername(ctx)
	assert.Nil(err)
	assert.Equal(username, receivedUsername)

}

func TestBadContext(t *testing.T) {
	assert := assert.New(t)

	ctx := context.Background()

	_, err := tokens.GetUserID(ctx)
	assert.NotNil(err)

	_, err = tokens.GetUsername(ctx)
	assert.NotNil(err)

}

func TestSetContext(t *testing.T) {
	assert := assert.New(t)

	idToUse := 3
	ctx := tokens.SetUserID(context.Background(), 3)
	receivedID, err := tokens.GetUserID(ctx)
	assert.Nil(err)
	assert.EqualValues(idToUse, receivedID)
}
